/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/CodeSegregation.java,v 1.1 2002/01/27 22:16:26 ikk Exp $ $Name:  $

  $Log: CodeSegregation.java,v $
  Revision 1.1  2002/01/27 22:16:26  ikk
  Initial.

*/

package aspects;

import java.sql.*;

public aspect CodeSegregation
{
    public static final String cvs="$Id: CodeSegregation.java,v 1.1 2002/01/27 22:16:26 ikk Exp $";

    pointcut dbCode()         : call(Connection DriverManager.getConnection(..));
    pointcut badDbCode()      : dbCode() && !within(db.*);
    pointcut reallyBadDbCode(): badDbCode() && !within(security.*) && !within(servlets.*);

    declare warning: badDbCode()      : "Database code outside 'db' package.";
    declare error  : reallyBadDbCode(): "Database code here is not permitted.";
}
