/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/Logger.java,v 1.1 2002/01/23 06:14:50 ikk Exp $ $Name:  $

  $Log: Logger.java,v $
  Revision 1.1  2002/01/23 06:14:50  ikk
  Initial.

*/

package aspects;

import servlets.*;

abstract public aspect Logger
{
    public static final String cvs="$Id: Logger.java,v 1.1 2002/01/23 06:14:50 ikk Exp $";

    abstract pointcut logPoint();

    before() : logPoint() && !within(Logger+) && !within(Init)
    {
        Init.log(thisJoinPoint.getTarget()+"/"+
                 thisJoinPoint.getThis()+"/"+
                 thisJoinPoint.getSignature());
    }
}
