/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/NewLogging.java,v 1.1 2002/02/12 05:43:30 ikk Exp $ $Name:  $

  $Log: NewLogging.java,v $
  Revision 1.1  2002/02/12 05:43:30  ikk
  Initial.

  Revision 1.1  2002/02/09 05:28:52  ikk
  Initial.

*/

package aspects;

import javax.servlet.*;

public aspect NewLogging
{
    public static final String cvs="$Id: NewLogging.java,v 1.1 2002/02/12 05:43:30 ikk Exp $";

    void around(String message) : 
    (
        call(void GenericServlet.log(String))
        ||
        call(void ServletContext.log(String))
    )
    && args(message)
    {
        System.out.println(message);
    }

    void around(String message, Throwable ex) : 
    (
        call(void GenericServlet.log(String, Throwable))
        ||
        call(void ServletContext.log(String, Throwable))
    )
    && args(message, ex)
    {
        System.out.println(message);
        ex.printStackTrace(System.out);
    }
}
