/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/NullChecker.java,v 1.2 2002/01/27 21:43:29 ikk Exp $ $Name:  $

  $Log: NullChecker.java,v $
  Revision 1.2  2002/01/27 21:43:29  ikk
  Removed importing of servlets package.

  Revision 1.1  2002/01/27 21:40:39  ikk
  Initial.

*/

package aspects;

public aspect NullChecker
{
    public static final String cvs="$Id: NullChecker.java,v 1.2 2002/01/27 21:43:29 ikk Exp $";

    pointcut arguments(): execution(* db.*.*(..));

    before() : arguments()
    {
        Object args[] = thisJoinPoint.getArgs();
        for(int i=0; i<args.length; i++)
        {
            if( null == args[i] )
            {
                throw new IllegalArgumentException("The argument is null.");
            }
            servlets.Init.log(thisJoinPointStaticPart.getSignature()+"["+i+"] -> " +args[i]);
        }
    }
}
