/*
  $Header: d:\\Personal\\cvs/aj/src/db/StoriesDb.java,v 1.5 2002/01/29 04:23:57 ikk Exp $ $Name:  $

  $Log: StoriesDb.java,v $
  Revision 1.5  2002/01/29 04:23:57  ikk
  Replaced Exception with SQLException.

  Revision 1.4  2002/01/21 01:40:14  ikk
  Replaced hardcoded parameters of getConnection().

  Revision 1.3  2002/01/21 00:21:23  ikk
  Removed JDBC driver loading.

  Revision 1.2  2002/01/08 23:27:42  ikk
  Added saveStories() method.

  Revision 1.1  2002/01/08 03:51:29  ikk
  Initial.

*/

package db;

import java.sql.*;
import java.util.*;
import servlets.Init;

public class StoriesDb
{
    public static final String cvs="$Id: StoriesDb.java,v 1.5 2002/01/29 04:23:57 ikk Exp $";

    public static Collection retrieve(String user) throws SQLException
    {
        Collection res = new ArrayList();

        Connection conn = DriverManager.getConnection(
            Init.getParameter("dburl"),
            Init.getParameter("dbuser"),
            Init.getParameter("dbpass"));
        Statement stmt = conn.createStatement();

    
        ResultSet rs = stmt.executeQuery("SELECT stories.category, stories.body FROM stories, preferences WHERE preferences.name='"+user+"' AND stories.category=preferences.category");

        while (rs.next())
        {
            res.add(new Story(rs.getString(1), rs.getString(2)));
        }

        conn.close();
        return res;
    }    

    public static Collection preferences(String user) throws SQLException
    {
        Collection res = new ArrayList();

        Connection conn = DriverManager.getConnection(
            Init.getParameter("dburl"),
            Init.getParameter("dbuser"),
            Init.getParameter("dbpass"));
        Statement stmt = conn.createStatement();

        ResultSet rs = stmt.executeQuery("SELECT category FROM preferences WHERE name='"+user+"'");

        while (rs.next())
        {
            res.add(rs.getString(1));
        }

        conn.close();
        return res;
    }

    public static void savePreferences(String user, Collection preferences) throws SQLException
    {
        Connection conn = DriverManager.getConnection(
            Init.getParameter("dburl"),
            Init.getParameter("dbuser"),
            Init.getParameter("dbpass"));
        Statement stmt = conn.createStatement();

        stmt.executeUpdate("DELETE FROM preferences WHERE name='"+user+"'");

        Iterator iterator = preferences.iterator();
        while(iterator.hasNext())
        {
            stmt.executeUpdate("INSERT INTO preferences (name, category) VALUES('"+user+"', '"+(String)iterator.next()+"')");
        }

        conn.close();
    }

    public static void saveStory(String category, String body) throws SQLException
    {
        Connection conn = DriverManager.getConnection(
            Init.getParameter("dburl"),
            Init.getParameter("dbuser"),
            Init.getParameter("dbpass"));
        Statement stmt = conn.createStatement();

        stmt.executeUpdate("INSERT INTO stories (category, body) VALUES('"+category+"', '"+body+"')");

        conn.close();
    }
}
