/*
  $Header: d:\\Personal\\cvs/aj/src/wrong/WrongBuffering2.java,v 1.2 2002/02/01 03:56:27 ikk Exp $ $Name:  $

  $Log: WrongBuffering2.java,v $
  Revision 1.2  2002/02/01 03:56:27  ikk
  Name changes.

  Revision 1.1  2002/02/01 02:25:33  ikk
  Initial.

*/

package wrong;

import java.io.*;

public aspect WrongBuffering2 pertarget(target(FileOutputStream))
{
    public static final String cvs="$Id: WrongBuffering2.java,v 1.2 2002/02/01 03:56:27 ikk Exp $";

    private static final int BUFF_SIZE=256;
    byte[] buff = new byte[BUFF_SIZE];
    int counter = 0;

    pointcut writeBytes(byte[] bytes):
    call(void FileOutputStream.write(byte[]))
    && args(bytes)
    && !within(WrongBuffering2);

    void around(byte[] bytes) throws IOException: writeBytes(bytes)
    {
        FileOutputStream out =
          (FileOutputStream)thisJoinPoint.getTarget();
        WrongBuffering2 wb = WrongBuffering2.aspectOf(out);
        if(wb.counter + bytes.length > BUFF_SIZE)
        {
            out.write(wb.buff, 0, wb.counter);
            out.write(bytes);
            
            wb.counter=0;
        }
        else
        {
            System.arraycopy(bytes, 0, wb.buff, wb.counter, bytes.length);
            wb.counter += bytes.length;
        }
    }
}

