/*
  $Header: d:\\Personal\\cvs/aj/src/language/PcdBase.java,v 1.2 2002/03/17 19:42:47 ikk Exp $ $Name:  $

  $Log: PcdBase.java,v $
  Revision 1.2  2002/03/17 19:42:47  ikk
  Changed within pointcut to exclude PcdBase and its children.

  Revision 1.1  2002/03/13 04:32:32  ikk
  Initial.

*/

abstract public aspect PcdBase
{
    public static final String cvs="$Id: PcdBase.java,v 1.2 2002/03/17 19:42:47 ikk Exp $";

    abstract pointcut p();

    before() : p()
    && !within(PcdBase+)
    {
        System.out.println(
            thisJoinPoint.getTarget()+                      " | "+
            thisJoinPoint.getThis()+                        " | "+
            thisJoinPoint.getSignature()+                   " | "+
            thisJoinPoint.getKind()+                        " | "+
            thisJoinPoint.getSourceLocation().getFileName()+" | "+
            thisJoinPoint.getSourceLocation().getLine()+    " | "+
            "");
    }

    static
    {
        System.out.println("Target | This | Signature | Kind | File | Line");
        System.out.println("-------|------|-----------|------|------|-----");
    }

}
