/*
  $Header: d:\\Personal\\cvs/aj/src/language/SCMain.java,v 1.2 2002/04/04 03:39:15 ikk Exp $ $Name:  $

  $Log: SCMain.java,v $
  Revision 1.2  2002/04/04 03:39:15  ikk
  Added output formatting.

  Revision 1.1  2002/04/01 00:17:43  ikk
  Initial.

*/

import java.util.*;

public class SCMain
{
    public static final String cvs="$Id: SCMain.java,v 1.2 2002/04/04 03:39:15 ikk Exp $";

    public static void main(String args[])
    {
        SCMain sc = new SCMain();
        Class scClass = sc.getClass();

        printArray("Constructors: ", scClass.getConstructors()   );
        printArray("Interfaces:   ", scClass.getInterfaces()     );
        printArray("Fields:       ", scClass.getDeclaredFields() );
        printArray("Methods:      ", scClass.getDeclaredMethods());
        printArray("Parents:      ", getHierarchy(scClass));

    }

    private static void printArray(String title, Object[] array)
    {
        System.out.println(title);
        for(int i=0; i<array.length; i++)
        {
            System.out.println("  "+array[i]);
        }
    }

    private static Object[] getHierarchy(Class aClass)
    {
        ArrayList result = new ArrayList();
        Class superClass = aClass;

        do
        {
            result.add(superClass);
            superClass = superClass.getSuperclass();
        }
        while(null != superClass);

        return result.toArray();
    }
}

