/*
  $Header: d:\\Personal\\cvs/aj/src/intro/Showcase.java,v 1.2 2002/01/01 00:47:16 ikk Exp $ $Name:  $

  $Log: Showcase.java,v $
  Revision 1.2  2002/01/01 00:47:16  ikk
  Work in progress.

  Revision 1.1  2001/12/27 20:52:39  ikk
  Initial

*/

package intro;

public aspect Showcase
{
    public static final String cvs="$Id: Showcase.java,v 1.2 2002/01/01 00:47:16 ikk Exp $";

    pointcut int_A_a_int():   call(int A.a(int));
    pointcut int_A_all_int(): call(int A.*(int));
    pointcut all_all_c_all(): call(* *.c(*));

    before(): int_A_a_int()
    {
        System.out.println("Before: " + thisJoinPoint);
    }

    after(): int_A_all_int() || all_all_c_all()
    {
        System.out.println("After: " + thisJoinPoint);
    }
    
    Object around(): all_all_c_all()
    {
        System.out.println("Start around: " + thisJoinPoint);
        Object o = proceed();
        System.out.println("End  around: " + thisJoinPoint);
        return o;
    }
}
