/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/PaidStories.java,v 1.1 2002/02/13 04:54:52 ikk Exp $ $Name:  $

  $Log: PaidStories.java,v $
  Revision 1.1  2002/02/13 04:54:52  ikk
  Initial.

*/

package aspects;

import db.*;
import java.util.*;

public aspect PaidStories
{
    public static final String cvs="$Id: PaidStories.java,v 1.1 2002/02/13 04:54:52 ikk Exp $";

    private double Story.price = 0;

    public void Story.setPrice(double price)
    {
        this.price = price;
    }

    public double Story.getPrice()
    {
        return price;
    }

    pointcut billThem(String user): call(Collection StoriesDb.retrieve(String)) && args(user);

    Collection around(String user) : billThem(user) 
    {
        Collection stories = proceed(user);

        for(Iterator i=stories.iterator(); i.hasNext(); )
        {
            Story story = (Story)i.next();
            chargeUser(user, story.getPrice());
        }
        
        return stories;
    }

    private void chargeUser(String user, double price)
    {
        // implementation goes here
    }
}

